//+------------------------------------------------------------------+
//|                                                      ZO-MACD.mq4 |
//+------------------------------------------------------------------+
#property copyright " 2007, OZ"
#property link      "finansovyj-dozor.narod.ru"
//----
#property indicator_separate_window
#property  indicator_buffers 4//  5     3    
                              //          
#property indicator_color1 Aqua
#property indicator_color2 Yellow
#property indicator_color3 Magenta
#property indicator_color4 Lime


#property indicator_color5 Red
#property indicator_color6 White
#property indicator_color7 Lime
 
#property indicator_level1 0
//---- input parameters       15-39-9 -  
extern int FastEMA = 14;//5;//9;//15; //7
extern int SlowEMA = 26;//22;//26;//55; //16  -    - D1
extern int SignalEMA = 9;//19;//7;//9;//9
extern int Price = 6;// 6 - PRICE_WEIGHTED
//0-PRICE_CLOSE, 1-PRICE_OPEN, 2-PRICE_HIGH, 3-PRICE_LOW, 4-PRICE_MEDIAN, 5-PRICE_TYPICAL, 6 - PRICE_WEIGHTED
extern int Mode = 2;//  1 - MODE_EMA
//0-MODE_SMA, 1 - MODE_EMA, 2-MODE_SMMA 3-MODE_LWMA,
extern int Draw = 2;//  2 - DRAW_HISTOGRAM, 1 - DRAW_SECTION, 0 - DRAW_LINE, 
extern int Shift=1; //   

extern string Zametki1="-  16.45!!!  -     ,       -     ";
extern string Zametki2="          -    ";
 
//---- buffers
double MACDBuffer[];
double SignalBuffer[];
double FastEMABuffer[];
double SlowEMABuffer[];
double SignalEMABuffer[];

double val1[];
double val2[];

//=================================================================================================
//----  ,     
#define S 1// SIGNAL_BAR 1    S 1  
//       SIGNAL_BAR   (1).

bool   uptrend, old;//   ,   

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(8);
   
     SetIndexStyle(0, DRAW_ARROW,1,2);//  Aqua  
     SetIndexArrow(0, 233);              //  - 164 - , 233 - 
     SetIndexBuffer(0, val1);      //    
//     SetIndexDrawBegin(0, 2*CHANNEL5);//                                                 ???????
     SetIndexLabel(0, "");
     SetIndexShift(0, Shift);
     
          
     SetIndexStyle(1, DRAW_ARROW,1,2);//  Yellow
     SetIndexArrow(1, 234);              //  - 164 - , 234 - 
     SetIndexBuffer(1, val2);      //    
//     SetIndexDrawBegin(1, 2*CHANNEL5);//                                                ???????
     SetIndexLabel(1, "");
     SetIndexShift(1, Shift);
     
   SetIndexBuffer(2, MACDBuffer);
   SetIndexBuffer(3, SignalBuffer);
   SetIndexBuffer(4, FastEMABuffer);
   SetIndexBuffer(5, SlowEMABuffer);
   SetIndexBuffer(6, SignalEMABuffer);
   SetIndexStyle(2, Draw, STYLE_SOLID, 2); // DRAW_HISTOGRAM, DRAW_LINE, 2 -   ,     
   SetIndexStyle(3, DRAW_LINE, 0, 1);// 0 -  
   SetIndexDrawBegin(2, SlowEMA);//MACDBuffer);//SlowEMA);
   SetIndexDrawBegin(3, SignalEMA);//SignalBuffer);//SignalEMA);//  SignalEMA          )
   
   //      
   IndicatorShortName("ZO-MACD(" + FastEMA + "," + SlowEMA + "," + SignalEMA + ")");
   SetIndexLabel(2, "ZO-MACD");
   SetIndexLabel(3, "ZO-Signal");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) 
       return(-1);
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars;
   double EMA, ZeroLagEMAp, ZeroLagEMAq;
   
    
   for(int i = 0; i < limit; i++)
     {
       FastEMABuffer[i] = iMA(NULL, 0, FastEMA, 0, MODE_EMA, PRICE_CLOSE, i);
       SlowEMABuffer[i] = iMA(NULL, 0, SlowEMA, 0, MODE_EMA, PRICE_CLOSE, i);
     }
   for(i = 0; i < limit; i++)
     {
        EMA = iMAOnArray(FastEMABuffer, Bars, FastEMA, 0, MODE_EMA, i);
        ZeroLagEMAp = FastEMABuffer[i] + FastEMABuffer[i] - EMA;
        EMA = iMAOnArray(SlowEMABuffer, Bars, SlowEMA, 0, MODE_EMA, i);
        ZeroLagEMAq = SlowEMABuffer[i] + SlowEMABuffer[i] - EMA;
        MACDBuffer[i] = (ZeroLagEMAp - ZeroLagEMAq);
     }
   for(i = 0; i < limit; i++)
       SignalEMABuffer[i] = iMAOnArray(MACDBuffer, Bars, SignalEMA, 0, MODE_SMA, i);// MODE_EMA
   for(i = 0; i < limit; i++)
     {
       EMA = iMAOnArray(SignalEMABuffer, Bars, SignalEMA, 0, MODE_SMA, i);// MODE_EMA
       SignalBuffer[i] = SignalEMABuffer[i] + SignalEMABuffer[i] - EMA;
     }
     
//==========================================================================================================================1
/*                            

   -    ,       , , 
     .     :

     .    ; 
  -    ,   (   ,      ); 
    , ,    -   . , ,    .
      -       . 
   . ==  ??? ==
        ,     . ==  ??? ==
*/
//                           , 

//     start -    return:
     
     //----  ,          
    static int PrevSignal = 0, PrevTime = 0;
 
    //----       0-,     
    //----  .     , .
    if(S >= 0 && Time[0] <= PrevTime ) //     -   - if(SIGNAL_BAR > 0 && Time[0] <= PrevTime )
        return(0);
    //---- ,    
    PrevTime = Time[0];
    
//   	   uptrend       =false;
//         old           =false;
//   	 val1[S] = PrevSignal;  // 
//     val2[S] = 0;  // 

//=========================================================================================================================2
// ,     start,    . 
//      . 
//             .
//   ,     ( ,  SIGNAL_BAR  0).

// :
    //----          (PrevSignal=0)
    if(PrevSignal <= 0)
      {
        //---- ,       :
        if(MACDBuffer[S] - SignalBuffer[S] > 0 && 
           SignalBuffer[S+1] - MACDBuffer[S+1] >= 0)
           //SignalBuffer[SIGNAL_BAR] > 0) //                    ZO -            
          {
//----  ,     -  =============================================================3
            PrevSignal = 1;                                     // ..      ???
            //----   :
 //  GlobalVariableSet("OZ-MACD",0);//("goSELL", 0); //     goSELL=0
 //  GlobalVariableSet("OZ-MACD",0);//("goBUY", 0);  //     goBUY =0
//       {
//       uptrend = true;  //                                                                           
//       }       
//       if(uptrend != old)//   && uptrend == true ) //       OLD   2   
       //{
        val1[S] =  SignalBuffer[S+1];//ExtMapBuffer51[i];//LowerBuf2[i]-(LowerBuf10[i]-LowerBuf2[i])*2;
            Alert("ZO-MACD (", Symbol(), ", ", Period(), ")  -  BUY!-- ");
//            Print("sMACD (", Symbol(), ", ", Period(), ")  -  BUY!!!");
//            Comment("sMACD (", Symbol(), ", ", Period(), ")  -  BUY!!!");
//            PlaySound("Alert.wav");

          }
      }


//----      =============================================================================4
    if(PrevSignal >= 0)
      {
        if(SignalBuffer[S] - MACDBuffer[S] > 0 && 
           MACDBuffer[S+1] - SignalBuffer[S+1] >= 0)
           //                                ZO -    
          {
            PrevSignal = -1;
 //  GlobalVariableSet("OZ-MACD",0);//("goSELL", 0); //     goSELL=0
 //  GlobalVariableSet("OZ-MACD",0);//("goBUY", 0);  //     goBUY =0
            
        val2[S] =  SignalBuffer[S+1];//ExtMapBuffer51[i];//LowerBuf2[i]-(LowerBuf10[i]-LowerBuf2[i])*2;
            Alert("ZO-MACD (", Symbol(), ", ", Period(), ")  -  SELL!-- ");
//            Print("sMACD (", Symbol(), ", ", Period(), ")  -  SELL!!!");
//            Comment("sMACD (", Symbol(), ", ", Period(), ")  -  SELL!!!");
//            PlaySound("Alert.wav");
          }
      }
  
//==============================================================================================================================


   return(0);
  }
//+------------------------------------------------------------------+


